subroutine sqrt2x2mat(a,b,c,wurzel)

  implicit none
  
  ! Input
  real*8 :: a,b,c 	!a,c = Diagonal-Elemente, b=Nebendiagonalel.
  
  ! Output
  real*8,dimension(2,2) :: wurzel
  
  ! Intern
  real*8,dimension(2,2) :: p,p_1,diag
  real*8 d1,d2
  
  d1 = sqrt(a*a + 4.0d0*b*b - 2.0d0*a*c + c*c)
  
  diag = 0.0d0
  diag(1,1)= 0.5d0*(a + c - d1)
  diag(2,2)= 0.5d0*(a + c + d1)
  diag = sqrt(diag)
  
  p(1,1) = 0.5d0*(a - c - d1)/b
  p(2,1) = 1.0d0
  d2 = sqrt(p(1,1)**2.0d0 + p(2,1)**2.0d0)
  p(1,1) = p(1,1)/d2
  p(2,1) = p(2,1)/d2
  
  p(1,2) = 0.5d0*(a - c + d1)/b
  p(2,2) = 1.0d0
  d2 = sqrt(p(1,2)**2.0d0 + p(2,2)**2.0d0)
  p(1,2) = p(1,2)/d2
  p(2,2) = p(2,2)/d2
  
  p_1(1,1) = p(1,1)
  p_1(2,1) = p(1,2)
  p_1(1,2) = p(2,1)
  p_1(2,2) = p(2,2)
  
  wurzel = matmul(p,diag)
  wurzel = matmul(wurzel,p_1)
  
end subroutine