subroutine inverse2x2mat(mat,inv)

  implicit none
  
  ! Input
  real*8,dimension(2,2) :: mat
  
  ! Output
  real*8,dimension(2,2) :: inv
  
  ! Intern
  real*8 a,b,c,d,dum
  
  a = mat(1,1)
  b = mat(1,2)
  c = mat(2,1)
  d = mat(2,2)
  
  dum = a*d - b*c
  
  inv(1,1) = d/dum
  inv(1,2) = -b/dum
  inv(2,1) = -c/dum
  inv(2,2) = a/dum
  
end subroutine